package giardini.orto;

import giardini.*;

public class OrtoFactory
implements GiardiniFactory
{
	public PiantaDaBordura getPiantaDaBordura(String vincoli)
	{
		//richiede una nuova if clause per ogni nuova pianta
		/*
		if(vincoli.equals("giardini.orto.Fagiolo"))
		{
			return new Fagiolo();
		}
		else
		{
			System.out.println("Non conosco la classe <" + vincoli + ">");
			return null;
		}
		*/

		try
		{
			Class clazz = Class.forName(vincoli);
			Object o = clazz.newInstance();
			if(o instanceof PiantaDaBordura)
			{
				//ok, la classe e' corretta
				return (PiantaDaBordura)o;
			}
			else
			{
				//la classe ottenuta non e' corretta
				return null;
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.exit(1);
		}
		return null;
	}

	public static void main(String[] argv)
	{
		int i = 0;
		OrtoFactory of = new OrtoFactory();
		for(i=0;i<argv.length;i++)
		{
			System.out.println(of.getPiantaDaBordura(argv[i]));
		}
	}
}
