package giardini.orto;

import giardini.*;
import java.io.*;
import java.util.*;

public class OrtoFactory2
implements GiardiniFactory
{
	static Map<String, Class> tabellaClassi;
	static boolean valid = false;

	public OrtoFactory2() throws InstantiationException
	{
		if(!valid)
		{
			throw new InstantiationException();
		}
	}

	public PiantaDaBordura getPiantaDaBordura(String vincoli)
	{
		try
		{
			Class clazz = tabellaClassi.get(vincoli);
			if(clazz == null)
			{
				System.err.println("Non conosco la classe <" + vincoli + ">");
				return null;
			}
			Object o = clazz.newInstance();
			if( !(o instanceof PiantaDaBordura))
			{
				System.err.println("La classe <" + vincoli + "> non e' del tipo PiantaDaBordura");
				return null;
			}
			return (PiantaDaBordura)o;
		}
		catch(InstantiationException ie)
		{
			ie.printStackTrace();
		}
		catch(IllegalAccessException iae)
		{
			iae.printStackTrace();
		}
		return null;
	}

	static
	{
		tabellaClassi = new HashMap<String, Class>();
		try
		{
			File f = new File("datiInizializzazione.txt");
			Scanner s = new Scanner(f);
			while(s.hasNextLine())
			{
				String line = s.nextLine();
				if(!line.equals("giardini.orto"))
				{
					System.out.println("Non mi interessano i dati per il <" + line + ">");
					s.nextLine();//consumo il nome della pianta
					s.nextLine();//consumo i dati di inizializzazione
				}
				else
				{
					//adesso leggo il nome della pianta, dei dati di inizializzazione ora non mi importa
					line = s.nextLine();
					s.nextLine();//consumo i dati di inizializzazione
					try
					{
						Class clazz = Class.forName(line);
						tabellaClassi.put(line, clazz);
					}
					catch(ExceptionInInitializerError eiie)
					{
						eiie.printStackTrace();
						System.exit(1);
					}
					catch(LinkageError le)
					{
						le.printStackTrace();
						System.exit(1);
					}
					catch(ClassNotFoundException cnfe)
					{
						cnfe.printStackTrace();
					}
				}
			}
			s.close();
			valid = true;
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
			valid = false;
		}
	}

	public static void main(String[] argv)
	{
		OrtoFactory2 of2 = null;
		try
		{
			of2 = new OrtoFactory2();
		}
		catch(InstantiationException ie)
		{
			ie.printStackTrace();
			return;
		}
		int i = 0;
		for(i=0;i<argv.length;i++)
		{
			Pianta p = of2.getPiantaDaBordura(argv[i]);
			System.out.println(p);
		}
	}

}
