package rubrica;
import java.util.*;

public class Rubrica
{

	Map<String, Nominativo> perNome, perCognome, perInput;

	public Rubrica()
	{
		perNome = new HashMap<String, Nominativo>();
		perCognome = new HashMap<String, Nominativo>();
		perInput = new HashMap<String, Nominativo>();
	}

	public Nominativo cercaPerNome(String ilNome)
	{
		return perNome.get(ilNome);
	}

	public Nominativo cercaPerCognome(String ilCognome)
	{
		return perCognome.get(ilCognome);
	}

	public Nominativo cercaPerInput(String loInput)
	{
		return perInput.get(loInput);
	}

	public int addNominativo(Nominativo ilNominativo)
	{
		perNome.put(ilNominativo.getNome(), ilNominativo);
		perCognome.put(ilNominativo.getCognome(), ilNominativo);
		perInput.put(ilNominativo.toString(), ilNominativo);
		return perNome.size();
	}

	public Nominativo removeNominativo(Nominativo ilNominativo)
	{
		Nominativo retval = perNome.remove(ilNominativo.getNome());
		perCognome.remove(ilNominativo.getCognome());
		perInput.remove(ilNominativo.toString());
		return retval;
	}

	public String toString()
	{
		String retval = "";
		Collection<Nominativo> nominativi = perNome.values();
		Iterator<Nominativo> iter = nominativi.iterator();
		while(iter.hasNext())
		{
			retval = retval.concat(iter.next().toString() + "; ");
		}
		return retval;
	}
}
