package sequenze;

public interface Sequenza<T>
{
	/**
	* Ritorna l'elemento in posizione index.
	*/
	T get(int index);

	/**
	* Ritorna il numero di elementi contenuti.
	*/
	int size();

	/**
	* Sostituisce l'elemento in posizione index con il valore element. Ritorna il precedente valore in posizione index.
	*/
	T set(int index, T element);

	/**
	* Inserisce il valore element in fondo alla coda. Ritorna true se lo puo' fare, false in caso di fallimento.
	*/
	boolean add(T element);

	/**
	* Factory method
	*/
	SeqIterator<T> seqIterator();
}
