package threads;

import java.util.*;
import java.util.concurrent.locks.*;

public class AttesaFIFO
{
	List<Work> lista = new LinkedList<Work>();
	Lock lock = new ReentrantLock();
	Condition attesa = lock.newCondition();


	public Object doIt(Executable e, Object param)
	{
		Work w = new Work();
		w.param = param;
		w.e = e;
		w.c = lock.newCondition();

		lock.lock();
		lista.add(w);
		attesa.signal();
		try
		{
			w.c.await();
		}
		catch(InterruptedException ie)
		{
			ie.printStackTrace();
		}

		lock.unlock();
		return w.retval;
	}

	class Worker
	implements Runnable
	{
		List<Work> lista;
		Condition attesa;
		Lock lock;

		Worker(Lock ilLock, List<Work> laLista, Condition laAttesa)
		{
			lista = laLista;
			attesa = laAttesa;
			lock = ilLock;
		}

		public void run()
		{
			while(true)
			{
				Work w = null;
				lock.lock();
				while(lista.isEmpty())
				{
					try
					{
						attesa.await();
					}
					catch(InterruptedException ie)
					{
						ie.printStackTrace();
					}
				}
				w = lista.remove(0);
				lock.unlock();

				//adesso eseguo il lavoro indipendentemente da cosa fanno gli altri
				w.retval = w.e.execute(w.param);

				lock.lock();
				w.c.signal();
				lock.unlock();
			}
		}
	}
}
