package threads;

public class Buffer<T>
{
	T[] storage;
	int head, tail, numEl;

	public Buffer(int size)
	{
		storage = (T[]) new Object[size];
		head = tail = numEl = 0;
	}

	public Buffer()
	{
		this(10);
	}

	public boolean isEmpty()
	{
		return size() == 0;
		// non e' meno efficiente di numEl == 0 perche' Java usa pesantemente
		// l'ottimizzazione di inlining
	}

	public boolean isFull()
	{
		return size() == storage.length;
	}

	public int size()
	{
		return numEl;
	}

	public synchronized T get()
	{
		while(isEmpty())
		{
			// attesa qui
			try
			{
				this.wait();
			}
			catch(InterruptedException ie)
			{
				ie.printStackTrace();
			}
		}

		T retval = storage[head];
		head = (head+1)%storage.length;
		numEl--;
		this.notify();
		return retval;
	}

	public synchronized void put(T elem)
	{
		while(isFull())
		{
			//qui attesa
			try
			{
				this.wait();
			}
			catch(InterruptedException ie)
			{
				ie.printStackTrace();
			}
		}

		storage[tail] = elem;
		tail = (tail+1)%storage.length;
		numEl++;
		notify();
	}
}
